diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
index 247dc4f2f..374e034f4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
@@ -11,13 +11,17 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.ICarriable;
+import net.minecraft.core.world.ICarrySource;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
+
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class TileEntityActivator extends TileEntity implements Container {
+public class TileEntityActivator extends TileEntity implements Container, ICarrySource {
     public static final int CONTAINER_SIZE = 9;
     private ItemStack[] dispenserContents;
     private final Random random;
@@ -228,10 +232,11 @@ public class TileEntityActivator extends TileEntity implements Container {
     }
 
     @Override
-    public boolean canBeCarried(World world, Entity potentialHolder) {
-        return true;
+    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
+        return super.pickup(world, holder, tilePos_);
     }
 
+
     @Override
     public CarriedBlock getCarriedEntry(World world, Entity holder, Block<?> currentBlock, int currentMeta) {
         return super.getCarriedEntry(world, holder, currentBlock, BlockLogicRotatable.setDirection(currentMeta, Direction.NORTH) /*Reset rotation, primarily to make it render in hand properly*/);
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index 67bee6f83..67f4f074d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -8,21 +8,24 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.world.save.conversion.ItemConverters;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketTileEntityData;
+import net.minecraft.core.world.ICarriable;
+import net.minecraft.core.world.ICarrySource;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
+
 import org.jetbrains.annotations.NotNull;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
 import static net.minecraft.core.world.save.conversion.ItemConverters.legacyBucketConverter;
 
-public class TileEntityBasket extends TileEntity {
+public class TileEntityBasket extends TileEntity implements ICarrySource {
     private int numUnitsInside = 0;
     private final Object2IntMap<BasketEntry> contents = new Object2IntArrayMap<>();
 
@@ -239,8 +242,8 @@ public class TileEntityBasket extends TileEntity {
     }
 
     @Override
-    public boolean canBeCarried(final World world, final Entity potentialHolder) {
-        return true;
+    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
+        return super.pickup(world, holder, tilePos_);
     }
 
     private static final class BasketEntry {
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
index 3102e18bd..4b05280a8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
@@ -13,13 +13,17 @@ import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.player.inventory.InventorySorter;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.ICarriable;
+import net.minecraft.core.world.ICarrySource;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
+
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 public class TileEntityChest extends TileEntity
-    implements Container
+    implements Container, ICarrySource
 {
     private static final Logger LOGGER = LogUtils.getLogger();
 
@@ -152,8 +156,8 @@ public class TileEntityChest extends TileEntity
     }
 
     @Override
-    public boolean canBeCarried(World world, Entity potentialHolder) {
-        return true;
+    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
+        return super.pickup(world, holder, tilePos_);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
index ffb16000b..91bdcd264 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
@@ -12,14 +12,18 @@ import net.minecraft.core.player.inventory.container.Container;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.ICarriable;
+import net.minecraft.core.world.ICarrySource;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
+
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
 public class TileEntityDispenser extends TileEntity
-    implements Container
+    implements Container, ICarrySource
 {
 
     public TileEntityDispenser()
@@ -215,8 +219,8 @@ public class TileEntityDispenser extends TileEntity
     }
 
     @Override
-    public boolean canBeCarried(World world, Entity potentialHolder) {
-        return true;
+    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
+        return super.pickup(world, holder, tilePos_);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index 8e56b16a6..006d87b58 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -13,13 +13,15 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemBucket;
-import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.ICarriable;
+import net.minecraft.core.world.ICarrySource;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -27,7 +29,7 @@ import java.util.List;
 import java.util.Random;
 
 public class TileEntityFurnace extends TileEntity
-        implements Container
+        implements Container, ICarrySource
 {
     public static final int SLOT_INGREDIENT = 0;
     public static final int SLOT_FUEL = 1;
@@ -333,40 +335,36 @@ public class TileEntityFurnace extends TileEntity
     @Override
     public void dropContents(World world, int x, int y, int z) {
         super.dropContents(world, x, y, z);
-        if(!BlockLogicFurnace.keepFurnaceInventory)
+        label0:
+        for(int l = 0; l < this.getContainerSize(); l++)
         {
-            label0:
-            for(int l = 0; l < this.getContainerSize(); l++)
+            ItemStack itemstack = this.getItem(l);
+            if(itemstack == null)
             {
-                ItemStack itemstack = this.getItem(l);
-                if(itemstack == null)
+                continue;
+            }
+            float f = random.nextFloat() * 0.8F + 0.1F;
+            float f1 = random.nextFloat() * 0.8F + 0.1F;
+            float f2 = random.nextFloat() * 0.8F + 0.1F;
+            do
+            {
+                if(itemstack.stackSize <= 0)
                 {
-                    continue;
+                    continue label0;
                 }
-                float f = random.nextFloat() * 0.8F + 0.1F;
-                float f1 = random.nextFloat() * 0.8F + 0.1F;
-                float f2 = random.nextFloat() * 0.8F + 0.1F;
-                do
+                int i1 = random.nextInt(21) + 10;
+                if(i1 > itemstack.stackSize)
                 {
-                    if(itemstack.stackSize <= 0)
-                    {
-                        continue label0;
-                    }
-                    int i1 = random.nextInt(21) + 10;
-                    if(i1 > itemstack.stackSize)
-                    {
-                        i1 = itemstack.stackSize;
-                    }
-                    itemstack.stackSize -= i1;
-                    EntityItem entityItem = new EntityItem(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
-                    float f3 = 0.05F;
-                    entityItem.xd = (float)random.nextGaussian() * f3;
-                    entityItem.yd = (float)random.nextGaussian() * f3 + 0.2F;
-                    entityItem.zd = (float)random.nextGaussian() * f3;
-                    world.entityJoinedWorld(entityItem);
-                } while(true);
-            }
-
+                    i1 = itemstack.stackSize;
+                }
+                itemstack.stackSize -= i1;
+                EntityItem entityItem = new EntityItem(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                float f3 = 0.05F;
+                entityItem.xd = (float)random.nextGaussian() * f3;
+                entityItem.yd = (float)random.nextGaussian() * f3 + 0.2F;
+                entityItem.zd = (float)random.nextGaussian() * f3;
+                world.entityJoinedWorld(entityItem);
+            } while(true);
         }
     }
 
@@ -398,8 +396,8 @@ public class TileEntityFurnace extends TileEntity
     }
 
     @Override
-    public boolean canBeCarried(World world, Entity potentialHolder) {
-        return true;
+    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
+        return super.pickup(world, holder, tilePos_);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
index 5414b53e6..61cfb1c7b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
@@ -17,8 +17,12 @@ import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.ICarriable;
+import net.minecraft.core.world.ICarrySource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -26,7 +30,7 @@ import java.util.List;
 import java.util.Random;
 
 public class TileEntityFurnaceBlast extends TileEntity
-    implements Container
+    implements Container, ICarrySource
 {
     public static final int SLOT_LEFT = 0;
     public static final int SLOT_RIGHT = 1;
@@ -295,32 +299,30 @@ public class TileEntityFurnaceBlast extends TileEntity
     @Override
     public void dropContents(final World world, final int x, final int y, final int z) {
         super.dropContents(world, x, y, z);
-        if (!BlockLogicFurnaceBlast.keepFurnaceInventory) {
-slotLoop:   for (int slot = 0; slot < this.getContainerSize(); slot++) {
-                final ItemStack item = this.getItem(slot);
-                if (item == null) {
-                    continue;
-                }
-                final float rx = this.random.nextFloat() * 0.8F + 0.1F;
-                final float ry = this.random.nextFloat() * 0.8F + 0.1F;
-                final float rz = this.random.nextFloat() * 0.8F + 0.1F;
-                do {
-                    if (item.stackSize <= 0) {
-                        continue slotLoop;
-                    }
-                    int stackSize = this.random.nextInt(21) + 10;
-                    if (stackSize > item.stackSize) {
-                        stackSize = item.stackSize;
-                    }
-                    item.stackSize -= stackSize;
-                    final EntityItem entityItem = new EntityItem(world, (float) x + rx, (float) y + ry, (float) z + rz, new ItemStack(item.itemID, stackSize, item.getMetadata()));
-                    final float velocityScale = 0.05F;
-                    entityItem.xd = (float) this.random.nextGaussian() * velocityScale;
-                    entityItem.yd = (float) this.random.nextGaussian() * velocityScale + 0.2F;
-                    entityItem.zd = (float) this.random.nextGaussian() * velocityScale;
-                    world.entityJoinedWorld(entityItem);
-                } while (true);
+        slotLoop: for (int slot = 0; slot < this.getContainerSize(); slot++) {
+            final ItemStack item = this.getItem(slot);
+            if (item == null) {
+                continue;
             }
+            final float rx = this.random.nextFloat() * 0.8F + 0.1F;
+            final float ry = this.random.nextFloat() * 0.8F + 0.1F;
+            final float rz = this.random.nextFloat() * 0.8F + 0.1F;
+            do {
+                if (item.stackSize <= 0) {
+                    continue slotLoop;
+                }
+                int stackSize = this.random.nextInt(21) + 10;
+                if (stackSize > item.stackSize) {
+                    stackSize = item.stackSize;
+                }
+                item.stackSize -= stackSize;
+                final EntityItem entityItem = new EntityItem(world, (float) x + rx, (float) y + ry, (float) z + rz, new ItemStack(item.itemID, stackSize, item.getMetadata()));
+                final float velocityScale = 0.05F;
+                entityItem.xd = (float) this.random.nextGaussian() * velocityScale;
+                entityItem.yd = (float) this.random.nextGaussian() * velocityScale + 0.2F;
+                entityItem.zd = (float) this.random.nextGaussian() * velocityScale;
+                world.entityJoinedWorld(entityItem);
+            } while (true);
         }
     }
 
@@ -352,8 +354,8 @@ slotLoop:   for (int slot = 0; slot < this.getContainerSize(); slot++) {
     }
 
     @Override
-    public boolean canBeCarried(final World world, final Entity potentialHolder) {
-        return true;
+    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
+        return super.pickup(world, holder, tilePos_);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
index 8151eceaf..1e6c941c6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
@@ -39,19 +39,25 @@ public class TileEntityJukebox extends TileEntity {
 
     @Override
     public void dropContents(World world, int x, int y, int z) {
-        if (record != 0) {
-            float f = 0.7F;
-            double d = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
-            double d1 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.2D + 0.6D;
-            double d2 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
-            EntityItem item = new EntityItem(world, (double) x + d, (double) y + d1, (double) z + d2, new ItemStack(record, 1, 0));
-            item.pickupDelay = 10;
-            world.entityJoinedWorld(item);
-
-            world.playBlockEvent(LevelListener.EVENT_JUKEBOX_TOGGLE, x, y, z, 0);
-            world.playRecord(null, null, x, y, z);
-            record = 0;
-            setChanged();
+        if (this.record == 0) return;
+        final float scale = 0.7F;
+        final double dx,dy,dz;
+        dx = (double) (world.rand.nextFloat() * scale) + (double) (1.0F - scale) * 0.5D;
+        dy = (double) (world.rand.nextFloat() * scale) + (double) (1.0F - scale) * 0.2D + 0.6D;
+        dz = (double) (world.rand.nextFloat() * scale) + (double) (1.0F - scale) * 0.5D;
+        final var item = new EntityItem(
+            world,
+            (double) x + dx, (double) y + dy, (double) z + dz,
+            new ItemStack(this.record, 1, 0)
+        );
+        item.pickupDelay = 10;
+        world.entityJoinedWorld(item);
+        world.playBlockEvent(LevelListener.EVENT_JUKEBOX_TOGGLE, x, y, z, 0);
+        world.playRecord(null, null, x, y, z);
+        this.record = 0;
+        setChanged();
+        if (this.worldObj != null) {
+            // fix falling block mutating data of other blocks
             world.setBlockMetadataWithNotify(x, y, z, 0);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
index c9fa51b5b..b22191f02 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
@@ -150,16 +150,11 @@ public class TileEntitySensor extends TileEntity {
                 this.carriedBlock.blockId = Blocks.MOTION_SENSOR_IDLE.id();
             }
         } else {
-            int meta = world.getBlockMetadata(this.tilePos.x, this.tilePos.y, this.tilePos.z);
-            int blockId;
-            if (active) {
-                blockId = Blocks.MOTION_SENSOR_ACTIVE.id();
-            } else {
-                blockId = Blocks.MOTION_SENSOR_IDLE.id();
-            }
-            world.setBlock(this.tilePos.x, this.tilePos.y, this.tilePos.z, blockId);
-            world.setBlockMetadata(this.tilePos.x, this.tilePos.y, this.tilePos.z, meta);
-            world.notifyBlockChange(this.tilePos.x, this.tilePos.y, this.tilePos.z, blockId);
+            int meta = world.getBlockData(this.tilePos);
+            final var block = (active)
+                ? Blocks.MOTION_SENSOR_ACTIVE
+                : Blocks.MOTION_SENSOR_IDLE;
+            world.setBlockTypeDataNotify(this.tilePos, block, meta);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index 2c305f854..21f4555e3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -19,13 +19,15 @@ import net.minecraft.core.entity.monster.MobSlime;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemBucket;
-import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.ICarriable;
+import net.minecraft.core.world.ICarrySource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -36,7 +38,7 @@ import java.util.Map;
 import java.util.Random;
 
 public class TileEntityTrommel extends TileEntity
-        implements Container
+        implements Container, ICarrySource
 {
     private static final Logger LOGGER = LogUtils.getLogger();
 
@@ -432,37 +434,34 @@ public class TileEntityTrommel extends TileEntity
     @Override
     public void dropContents(World world, int x, int y, int z) {
         super.dropContents(world, x, y, z);
-        if (!BlockLogicTrommel.keepTrommelInventory)
+        if(world.getTileEntity(x, y, z) != null)
         {
-            if(world.getTileEntity(x, y, z) != null)
+            label0:
+            for (int l = 0; l < getContainerSize(); l++)
             {
-                label0:
-                for (int l = 0; l < getContainerSize(); l++)
-                {
-                    ItemStack itemstack = getItem(l);
-                    if (itemstack == null) {
-                        continue;
-                    }
-                    float f = this.random.nextFloat() * 0.8F + 0.1F;
-                    float f1 = this.random.nextFloat() * 0.8F + 0.1F;
-                    float f2 = this.random.nextFloat() * 0.8F + 0.1F;
-                    do {
-                        if (itemstack.stackSize <= 0) {
-                            continue label0;
-                        }
-                        int i1 = this.random.nextInt(21) + 10;
-                        if (i1 > itemstack.stackSize) {
-                            i1 = itemstack.stackSize;
-                        }
-                        itemstack.stackSize -= i1;
-                        EntityItem item = new EntityItem(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
-                        float f3 = 0.05F;
-                        item.xd = (float) this.random.nextGaussian() * f3;
-                        item.yd = (float) this.random.nextGaussian() * f3 + 0.2F;
-                        item.zd = (float) this.random.nextGaussian() * f3;
-                        world.entityJoinedWorld(item);
-                    } while (true);
+                ItemStack itemstack = getItem(l);
+                if (itemstack == null) {
+                    continue;
                 }
+                float f = this.random.nextFloat() * 0.8F + 0.1F;
+                float f1 = this.random.nextFloat() * 0.8F + 0.1F;
+                float f2 = this.random.nextFloat() * 0.8F + 0.1F;
+                do {
+                    if (itemstack.stackSize <= 0) {
+                        continue label0;
+                    }
+                    int i1 = this.random.nextInt(21) + 10;
+                    if (i1 > itemstack.stackSize) {
+                        i1 = itemstack.stackSize;
+                    }
+                    itemstack.stackSize -= i1;
+                    EntityItem item = new EntityItem(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                    float f3 = 0.05F;
+                    item.xd = (float) this.random.nextGaussian() * f3;
+                    item.yd = (float) this.random.nextGaussian() * f3 + 0.2F;
+                    item.zd = (float) this.random.nextGaussian() * f3;
+                    world.entityJoinedWorld(item);
+                } while (true);
             }
         }
     }
@@ -573,8 +572,8 @@ public class TileEntityTrommel extends TileEntity
     }
 
     @Override
-    public boolean canBeCarried(World world, Entity potentialHolder) {
-        return true;
+    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
+        return super.pickup(world, holder, tilePos_);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java b/game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
index 316bef176..88391617f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
@@ -13,10 +13,12 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
+
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class CarriedBlock implements ICarriable {
+public class CarriedBlock implements ICarriable, ICarriedBlock {
     public int blockId; // TODO replace with direct block ref
     public int metadata;
     public @Nullable TileEntity entity;
@@ -64,12 +66,13 @@ public class CarriedBlock implements ICarriable {
 
             Block<?> currentBlock = world.getBlock(x, y, z);
             if (currentBlock != null && !currentBlock.hasTag(BlockTags.PLACE_OVERWRITES)) return false;
-            world.setBlockAndMetadataWithNotify(x, y, z, blockId, metadata);
+            world.setBlockAndMetadata(x, y, z, blockId, metadata);
 
             Block<?> b = world.getBlock(x, y, z);
             if (b != null && holder instanceof Mob) {
                 b.onBlockPlacedByMob(world, x, y, z, side, (Mob) holder, xPlaced, yPlaced);
             }
+            world.notifyBlockChange(x, y, z, blockId);
             return true;
         }
     }
@@ -96,16 +99,6 @@ public class CarriedBlock implements ICarriable {
         }
     }
 
-    @Override
-    public boolean canBeCarried(World world, Entity potentialHolder) {
-        return true;
-    }
-
-    @Override
-    public ICarriable pickup(World world, Entity holder) {
-        return this;
-    }
-
     @Override
     public void writeToNBT(CompoundTag tag) {
         if (entity != null) {
@@ -135,4 +128,14 @@ public class CarriedBlock implements ICarriable {
         carriedBlock.readFromNBT(tag);
         return carriedBlock;
     }
+
+    @Override
+    public int metadata() {
+        return metadata;
+    }
+
+    @Override
+    public @Nullable TileEntity entity() {
+        return entity;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/motion/ICarriedBlock.java b/game/core/src/main/java/net/minecraft/core/block/motion/ICarriedBlock.java
new file mode 100644
index 000000000..15551993c
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/motion/ICarriedBlock.java
@@ -0,0 +1,15 @@
+package net.minecraft.core.block.motion;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.TileEntity;
+
+public interface ICarriedBlock {
+    @NotNull Block<?> block();
+    int metadata();
+    default @Nullable TileEntity entity() {
+        return null;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
index c4dfde503..0b7d5745b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
@@ -216,10 +216,4 @@ public class TileEntityMovingPistonBlock extends TileEntity
         compoundTag.putFloat("progress", this.progressO);
         compoundTag.putBoolean("extending", this.extending);
     }
-
-    @Override
-    public boolean canBeCarried(World world, Entity potentialHolder) {
-        // Explicitly defined as false since the MovingPistonBlock should *never* be carried
-        return false;
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 6a57f5029..b5ba3bd35 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -1141,7 +1141,7 @@ public abstract class Player
         setSize(0.2F, 0.2F);
         if (this.world.isBlockLoaded(x, y, z)) {
             int meta = this.world.getBlockMetadata(x, y, z);
-            int dir = BlockLogicBed.getDirection(meta);
+            int dir = BlockLogicBed.DIRECTION.get(meta);
             float xOff = 0.5F;
             float zOff = 0.5F;
 
@@ -1197,7 +1197,8 @@ public abstract class Player
         TilePos bedPos = this.bedTilePos;
         Block<?> b;
         if (bedPos != null && (b = this.world.getBlockType(bedPos)) != null && b.getLogic() instanceof BlockLogicBed) {
-            BlockLogicBed.setBedOccupied(this.world, bedPos, false);
+            final var data = this.world.getBlockData(bedPos);
+            this.world.setBlockData(bedPos, BlockLogicBed.IS_OCCUPIED.set(data, 0));
             TilePos emptyPos = BlockLogicBed.getNearestEmptyTilePos(this.world, bedPos, 0);
             if (emptyPos == null) {
                 emptyPos = bedPos.up(new TilePos());
@@ -1236,9 +1237,8 @@ public abstract class Player
 
     public float getBedOrientationInDegrees() {
         if (this.bedTilePos != null) {
-            int i = this.world.getBlockMetadata(this.bedTilePos.x, this.bedTilePos.y, this.bedTilePos.z);
-            int j = BlockLogicBed.getDirection(i);
-            switch (j) {
+            int data = this.world.getBlockData(this.bedTilePos);
+            switch (BlockLogicBed.DIRECTION.get(data)) {
                 case 0: // '\0'
                     return 90F;
 
